<template>
  <div>
    <modal
      id="add-activity"
      class="add-food-modal"
      size="800px"
      :show.sync="show"
      :footer="false"
    >
      <div class="add-food-wrapper">
        <div class="add-food-tabs">
          <header class="bg-gradient-primary">
            <input
              :value="search"
              type="search"
              class="form-control mb-2 font-8"
              placeholder="دنبال چه فعالیتی میگردی؟"
              @input="search = $event.target.value"
            />
            <ul class="tabs list-unstyled">
              <li
                v-for="(tabName, tab) in tabs"
                :key="tab"
                :class="{ active: activeTab === tab }"
                @click="activeTab = tab"
              >
                <span>{{ tabName }}</span>
              </li>
            </ul>
          </header>
          <loader
            v-if="activeTab === 'activity'"
            :loading="activityLoading"
            class="tabs-content"
          >
            <div class="content">
              <ul>
                <li
                  v-for="activity in filteredActivities"
                  :key="activity.id"
                  :class="{
                    active: selected && selected.id === activity.id
                  }"
                  @click="selected = activity"
                >
                  {{ activity.title }}
                </li>
              </ul>
            </div>
          </loader>
          <loader
            v-if="activeTab === 'favorite'"
            :loading="favoriteLoading"
            class="tabs-content"
          >
            <div class="content">
              <ul>
                <li
                  v-for="activity in filteredFavorites"
                  :key="activity.id"
                  :class="{
                    active: selected && selected.id === activity.id
                  }"
                  @click="selected = activity"
                >
                  {{ activity.title }}
                </li>
              </ul>
            </div>
          </loader>
        </div>
        <div class="add-food-result" :class="{ active: selected }">
          <transition name="zoom-out-in" mode="out-in">
            <div
              v-if="selected"
              :key="selected.id"
              class="select-food-details text-center pt-5 pb-3"
            >
              <div>
                <div
                  class="image-circle has-border"
                  :style="{ backgroundImage: `url(${selected.img})` }"
                />
                <p class="text-primary">{{ selected.title }}</p>
              </div>

              <div>
                <p class="mt-1 mb-1 text-bold">انتخاب واحد اندازه گیری</p>
                <horizontal-select
                  v-model="form.unitId"
                  :options="units"
                  class="unit-select"
                />
                <p class="mt-3 mb-1 text-bold">انتخاب میزان مصرف</p>
                <input-number v-model="form.unitValue" :min="1" />
              </div>

              <div class="button-group">
                <button
                  type="button"
                  class="btn btn-circle btn-default ml-3 btn-cancel"
                  @click="selected = null"
                >
                  <v-icon name="arrow-right" width="24" />
                </button>
                <button
                  type="button"
                  class="btn btn-success font-9 btn-submit"
                  @click="submit"
                >
                  <span>تایید</span>
                  <span>({{ calorie }} کالری)</span>
                </button>
              </div>
            </div>
            <p v-else class="empty-text mb-0">لطفا یک فعالیت انتخاب کنید</p>
          </transition>
        </div>
      </div>
      <v-icon name="x" class="close-modal" @click.native="show = false" />
    </modal>
  </div>
</template>

<script>
import HorizontalSelect from '../helper/HorizontalSelect'
import InputNumber from '../helper/inputNumber/InputNumber'
export default {
  name: 'AddModal',
  components: { HorizontalSelect, InputNumber },
  props: {
    active: { type: [Boolean, Number], default: false }
  },
  data() {
    return {
      // loading keys
      activityLoading: false,
      favoriteLoading: false,

      //searched text
      search: '',

      // active tab
      activeTab: 'activity',

      selected: null,

      units: [
        { id: 199, title: 'ساعت', value: 60 },
        { id: 200, title: 'دقیقه', value: 1 }
      ],

      form: {
        unitId: 0,
        unitValue: 1
      },
      tabs: {
        activity: 'فعالیت ها',
        favorite: 'مورد علاقه'
      }
    }
  },
  computed: {
    show: {
      set(val) {
        if (!val) this.selected = null
        this.$emit('update:active', !!val)
      },
      get() {
        return !!this.active
      }
    },
    calorie() {
      let activity = this.selected
      if (!activity) return 0

      let unit = this.units.find(u => u.id === this.form.unitId)
      if (!unit) return 0

      return Math.round(unit.value * activity.calorie * this.form.unitValue)
    },
    filteredActivities() {
      let activities = this.$store.state.activity.activities
      if (this.search === '') return activities
      return activities.filter(f => f.search.includes(this.search))
    },
    filteredFavorites() {
      let activities = this.$store.getters['activity/favoriteActivities']
      if (this.search === '') return activities
      return activities.filter(f => f.search.includes(this.search))
    }
  },
  watch: {
    selected: {
      handler(activity) {
        if (activity && activity.id) {
          this.form.unitId = this.units[0].id
        }
        let query = this.$route.query
        if (activity && activity.id) {
          this.$router[query.selected ? 'replace' : 'push']({
            query: {
              ...query,
              selected: activity.id
            }
          })
        } else if (query.selected) {
          this.$router.back()
        }
      },
      deep: true
    },
    'form.unitId'(unitId) {
      this.form.unitValue = this.$config.unitsPreValue[unitId] || 1
    },
    active(val) {
      if (val) this.getActivities()
      // unset selected activity in phone
      // due to showing activities list
      if (window.innerWidth < 768) {
        this.selected = null
      }
    },
    activeTab(tab) {
      if (tab === 'favorite') this.getFavorites()
      // empty the search input
      this.search = ''
    },
    $route: {
      handler(after) {
        let q = after.query
        let activity = this.selected
        if (q.selected) {
          let qid = q.selected * 1
          if (activity && activity.id === qid) return
          activity = this.$store.state.activity.activities.find(
            f => f.id === qid
          )
          if (activity) this.selected = activity
        } else {
          this.selected = null
        }
      },
      immediate: true,
      deep: true
    }
  },
  methods: {
    getActivities() {
      if (this.$store.state.activity.activities.length) return
      this.$store.dispatch('activity/getAllActivities', {
        $vm: this,
        $loadingKey: 'activityLoading'
      })
    },
    getFavorites() {
      if (this.$store.state.activity.favoriteActivities.length) return
      this.$store.dispatch('activity/getFavoriteActivities', {
        $vm: this,
        $loadingKey: 'favoriteLoading'
      })
    },
    submit() {
      let msg = null
      if (!this.selected) msg = 'هیچ فعالیتی انتخاب نشده!'
      if (!this.form.unitId) msg = 'واحد انتخاب نشده!'
      if (!this.form.unitValue) msg = 'مقدار واحد انتخاب نشده'
      if (msg) return this.$message.error(msg)
      let unit = this.units.find(u => u.id === this.form.unitId) || {}
      this.$emit('submit', {
        activityId: this.selected.id,
        amount: this.form.unitValue * unit.value,
        calorie: this.calorie
      })
      this.selected = null
    }
  }
}
</script>
